create this repo. 2024.11.13
-------------------------------------------------
2024.11.13

create dev branch from main.
-------------------------------------------------
2024.12.15

use the basis of HUST

ACKNOWLEDGMENT

This project is based on work from the HUST project, which in turn uses code from the MIT project. We have made modifications and removed external information originally provided by HUST. We would like to acknowledge and thank the HUST team for their contributions.

The HUST project uses the project from MIT, which is available at: https://github.com/mit-pdos/xv6-riscv.git

And the repo of HUST project is available at: https://github.com/HUST-OS/xv6-k210

WE REFER THE PROJECT OF HUST AND THANKS FOR THEIR WORK!
-------------------------------------------------
2024-04-27

Implement Priority-Based Scheduling in Scheduler

- **Add `priority` Field:**
  - Introduced a new `int priority;` field in the `struct proc` within `proc.h` to store the priority of each process.
  
- **Initialize Process Priority:**
  - Updated the `procinit()` function in `proc.c` to set a default priority (`p->priority = 10;`) for each process during initialization.
  
- **Modify Scheduler for Priority Scheduling:**
  - Enhanced the `scheduler()` function in `proc.c` to implement priority-based scheduling.
  - Traverses the process table to identify the runnable process with the highest priority.
  - Ensures that the highest priority process is selected for execution by comparing the `priority` fields.
  
- **Improve Lock Management:**
  - Adjusted lock acquisition and release logic to prevent deadlocks and ensure proper synchronization.
  - Ensured that locks on previously selected highest priority processes are released before selecting a new one.
  - Added comments to clarify the rationale behind lock handling during the scheduling process.
  
- **Ensure System Stability:**
  - Verified that the scheduler correctly handles cases where no runnable processes are available by entering a low-power state (`wfi`) without holding any locks.
  - Maintained consistency in `c->proc` to accurately reflect the currently running process.

**Summary:**
This commit enhances the process scheduler by introducing a priority-based scheduling algorithm. By adding a priority field to each process and modifying the scheduler to select the highest priority runnable process, the system achieves better responsiveness and resource management. Additionally, improvements in lock management ensure that the scheduler operates reliably without introducing concurrency issues.

change the outpu of user func ls's print form, diaplay the dir size and permissions.
-------------------------------------------------
2024-12-23
### Improvements to Memory Allocation in kalloc.c

1. **Buddy System Implementation**
   - Introduced a buddy system for efficient memory allocation and deallocation.
   - Supports allocation of memory blocks in sizes that are powers of two, reducing fragmentation.

2. **Data Structures**
   - Added `struct free_area` to manage free lists for different block sizes.
   - Added `buddy` structure to hold the free lists and a spinlock for synchronization.

3. **Initialization**
   - Modified `kinit()` to initialize the buddy system and free lists.
   - Uses `freerange()` to initialize the free memory starting from `kernel_end`.

4. **Memory Allocation**
   - Implemented `buddy_alloc()` function to allocate memory blocks using the buddy system.
   - Ensures efficient splitting and merging of memory blocks.

5. **Memory Deallocation**
   - Modified `kfree()` to handle memory deallocation and merging of free blocks in the buddy system.

**Summary:**
The modifications to kalloc.c have significantly improved the memory allocation mechanism by introducing a buddy system. This system enhances memory allocation efficiency, reduces fragmentation, and ensures better utilization of available memory. The changes include the introduction of new data structures, enhancements to initialization, and the implementation of efficient allocation and deallocation functions. These improvements collectively contribute to a more robust and efficient memory management system in the kernel.